#ifndef SCREEN_HH
# define SCREEN_HH_

# include <ncurses.h>

#define CMD_BUFFER_SIZE 512

#define KEY_RETURN 10
#define KEY_EOF 4

class Screen {
public:
  Screen();
  void init();
  void login();
  void run();

friend Screen &operator<< (Screen &, const string &s);
friend Screen &operator<< (Screen &, int i);

private:
  void create_windows();
  void cmd_draw();
  void msg_draw();
  bool add_char(char c, char *string, ssize_t offset, size_t buf_len);
  bool del_char(char *string, ssize_t offset, size_t buf_len);
  void sigwinch(int);

private:
  WINDOW *msg_;

  // cmd window
  WINDOW *cmd_;
  char cmd_buffer_[CMD_BUFFER_SIZE];
  char cmd_history_buffer_[CMD_BUFFER_SIZE];
  size_t cmd_buf_off_;
  size_t cmd_win_off_;
  size_t cmd_history_off_;
};

#endif
